/* Copyright 2012, Unpublished Work of Technologic Systems
 * All Rights Reserved.
 *
 * THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
 * PROPRIETARY AND TRADE SECRET INFORMATION OF TECHNOLOGIC SYSTEMS.
 * ACCESS TO THIS WORK IS RESTRICTED TO (I) TECHNOLOGIC SYSTEMS 
 * EMPLOYEES WHO HAVE A NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE
 * OF THEIR ASSIGNMENTS AND (II) ENTITIES OTHER THAN TECHNOLOGIC
 * SYSTEMS WHO HAVE ENTERED INTO APPROPRIATE LICENSE AGREEMENTS.  NO
 * PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED, 
 * DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED, 
 * EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED, ADAPTED
 * IN ANY FORM OR BY ANY MEANS, MANUAL, MECHANICAL, CHEMICAL, 
 * ELECTRICAL, ELECTRONIC, OPTICAL, BIOLOGICAL, OR OTHERWISE WITHOUT
 * THE PRIOR WRITTEN PERMISSION AND CONSENT OF TECHNOLOGIC SYSTEMS.
 * ANY USE OR EXPLOITATION OF THIS WORK WITHOUT THE PRIOR WRITTEN
 * CONSENT OF TECHNOLOGIC SYSTEMS COULD SUBJECT THE PERPETRATOR TO
 * CRIMINAL AND CIVIL LIABILITY.
 */

module wb_ram_4kbyte(
  wb_clk_i,
  wb_rst_i,

  wb1_cyc_i,
  wb1_cti_i,
  wb1_bte_i,
  wb1_stb_i,
  wb1_we_i,
  wb1_adr_i,
  wb1_dat_i,
  wb1_sel_i,
  wb1_dat_o,
  wb1_ack_o,

  wb2_cyc_i,
  wb2_stb_i,
  wb2_cti_i,
  wb2_bte_i,
  wb2_we_i,
  wb2_adr_i,
  wb2_dat_i,
  wb2_sel_i,
  wb2_dat_o,
  wb2_ack_o,

  wb3_cyc_i,
  wb3_stb_i,
  wb3_cti_i,
  wb3_bte_i,
  wb3_we_i,
  wb3_adr_i,
  wb3_dat_i,
  wb3_sel_i,
  wb3_dat_o,
  wb3_ack_o,

  wb4_cyc_i,
  wb4_stb_i,
  wb4_cti_i,
  wb4_bte_i,
  wb4_we_i,
  wb4_adr_i,
  wb4_dat_i,
  wb4_sel_i,
  wb4_dat_o,
  wb4_ack_o
);

input wb_clk_i, wb_rst_i;

input wb1_cyc_i, wb1_stb_i, wb1_we_i;
input [3:0] wb1_sel_i;
input [31:0] wb1_adr_i, wb1_dat_i;
output [31:0] wb1_dat_o;
output wb1_ack_o;
input [2:0] wb1_cti_i;
input [1:0] wb1_bte_i;

input wb2_cyc_i, wb2_stb_i, wb2_we_i;
input [3:0] wb2_sel_i;
input [31:0] wb2_adr_i, wb2_dat_i;
output [31:0] wb2_dat_o;
output wb2_ack_o;
input [2:0] wb2_cti_i;
input [1:0] wb2_bte_i;

input wb3_cyc_i, wb3_stb_i, wb3_we_i;
input [3:0] wb3_sel_i;
input [31:0] wb3_adr_i, wb3_dat_i;
output [31:0] wb3_dat_o;
output wb3_ack_o;
input [2:0] wb3_cti_i;
input [1:0] wb3_bte_i;

input wb4_cyc_i, wb4_stb_i, wb4_we_i;
input [3:0] wb4_sel_i;
input [31:0] wb4_adr_i, wb4_dat_i;
output [31:0] wb4_dat_o;
output wb4_ack_o;
input [2:0] wb4_cti_i;
input [1:0] wb4_bte_i;

wire [31:0] wb_adr_i;
wire [31:0] wb_dat_i;
wire [3:0] wb_sel_i;
wire [31:0] wb_dat_o;
wire [2:0] wb_cti_i;
wire [1:0] wb_bte_i;
wire wb_ack_o, wb_cyc_i, wb_stb_i, wb_we_i;
wb_arbiter arbitercore(
  .wb_clk_i(wb_clk_i),

  .wbowner_dat_o(wb_dat_i),
  .wbowner_dat_i(wb_dat_o),
  .wbowner_adr_o(wb_adr_i),
  .wbowner_cyc_o(wb_cyc_i),
  .wbowner_stb_o(wb_stb_i),
  .wbowner_we_o(wb_we_i),
  .wbowner_ack_i(wb_ack_o),
  .wbowner_sel_o(wb_sel_i),
  .wbowner_cti_o(wb_cti_i),
  .wbowner_bte_o(wb_bte_i),

  .wb1_adr_i(wb1_adr_i),
  .wb1_dat_i(wb1_dat_i),
  .wb1_dat_o(wb1_dat_o),
  .wb1_cyc_i(wb1_cyc_i),
  .wb1_stb_i(wb1_stb_i),
  .wb1_we_i(wb1_we_i),
  .wb1_ack_o(wb1_ack_o),
  .wb1_sel_i(wb1_sel_i),
  .wb1_cti_i(wb1_cti_i),
  .wb1_bte_i(wb1_bte_i),

  .wb2_adr_i(wb2_adr_i),
  .wb2_dat_i(wb2_dat_i),
  .wb2_dat_o(wb2_dat_o),
  .wb2_cyc_i(wb2_cyc_i),
  .wb2_stb_i(wb2_stb_i),
  .wb2_we_i(wb2_we_i),
  .wb2_ack_o(wb2_ack_o),
  .wb2_sel_i(wb2_sel_i),
  .wb2_cti_i(wb2_cti_i),
  .wb2_bte_i(wb2_bte_i),

  .wb3_adr_i(wb3_adr_i),
  .wb3_dat_i(wb3_dat_i),
  .wb3_dat_o(wb3_dat_o),
  .wb3_cyc_i(wb3_cyc_i),
  .wb3_stb_i(wb3_stb_i),
  .wb3_we_i(wb3_we_i),
  .wb3_ack_o(wb3_ack_o),
  .wb3_sel_i(wb3_sel_i),
  .wb3_cti_i(wb3_cti_i),
  .wb3_bte_i(wb3_bte_i),

  .wb4_adr_i(wb4_adr_i),
  .wb4_dat_i(wb4_dat_i),
  .wb4_dat_o(wb4_dat_o),
  .wb4_cyc_i(wb4_cyc_i),
  .wb4_stb_i(wb4_stb_i),
  .wb4_we_i(wb4_we_i),
  .wb4_ack_o(wb4_ack_o),
  .wb4_sel_i(wb4_sel_i),
  .wb4_cti_i(wb4_cti_i),
  .wb4_bte_i(wb4_bte_i)
);

reg ack;
assign wb_ack_o = ack;
always @(posedge wb_clk_i or posedge wb_rst_i) begin
  if (wb_rst_i) ack <= 1'b0;
  else ack <= wb_cyc_i && wb_stb_i && !ack;
end

wire [3:0] ram_we = (wb_cyc_i && wb_stb_i && wb_we_i && ack) ? wb_sel_i : 4'h0;
ram_4kbyte ram_core (
  .clka(wb_clk_i),
  .wea(ram_we),
  .addra(wb_adr_i[11:2]),
  .dina(wb_dat_i),
  .douta(wb_dat_o)
);

endmodule
