/* Copyright 2012, Unpublished Work of Technologic Systems
 * All Rights Reserved.
 *
 * THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
 * PROPRIETARY AND TRADE SECRET INFORMATION OF TECHNOLOGIC SYSTEMS.
 * ACCESS TO THIS WORK IS RESTRICTED TO (I) TECHNOLOGIC SYSTEMS 
 * EMPLOYEES WHO HAVE A NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE
 * OF THEIR ASSIGNMENTS AND (II) ENTITIES OTHER THAN TECHNOLOGIC
 * SYSTEMS WHO HAVE ENTERED INTO APPROPRIATE LICENSE AGREEMENTS.  NO
 * PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED, 
 * DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED, 
 * EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED, ADAPTED
 * IN ANY FORM OR BY ANY MEANS, MANUAL, MECHANICAL, CHEMICAL, 
 * ELECTRICAL, ELECTRONIC, OPTICAL, BIOLOGICAL, OR OTHERWISE WITHOUT
 * THE PRIOR WRITTEN PERMISSION AND CONSENT OF TECHNOLOGIC SYSTEMS.
 * ANY USE OR EXPLOITATION OF THIS WORK WITHOUT THE PRIOR WRITTEN
 * CONSENT OF TECHNOLOGIC SYSTEMS COULD SUBJECT THE PERPETRATOR TO
 * CRIMINAL AND CIVIL LIABILITY.
 */

/* What it says on the tin: just a block of wishbone registers.
 * 16 registers, 32 bits wide.
 */

module wb_reg_block(
  wb_clk_i,
  wb_rst_i,

  wb_cyc_i,
  wb_stb_i,
  wb_we_i,
  wb_adr_i,
  wb_dat_i,
  wb_sel_i,
  wb_dat_o,
  wb_ack_o,

  reg0_i,
  reg0_o,
  reg1_i,
  reg1_o,
  reg2_i,
  reg2_o,
  reg3_i,
  reg3_o,
  reg4_i,
  reg4_o,
  reg5_i,
  reg5_o,
  reg6_i,
  reg6_o,
  reg7_i,
  reg7_o,
  reg8_i,
  reg8_o,
  reg9_i,
  reg9_o,
  reg10_i,
  reg10_o,
  reg11_i,
  reg11_o,
  reg12_i,
  reg12_o,
  reg13_i,
  reg13_o,
  reg14_i,
  reg14_o,
  reg15_i,
  reg15_o
);

input wb_clk_i, wb_rst_i, wb_cyc_i, wb_stb_i, wb_we_i;
input [31:0] wb_adr_i;
input [31:0] wb_dat_i;
input [3:0] wb_sel_i;
output [31:0] wb_dat_o;
output wb_ack_o;

input [31:0] reg0_i;
output [31:0] reg0_o;
input [31:0] reg1_i;
output [31:0] reg1_o;
input [31:0] reg2_i;
output [31:0] reg2_o;
input [31:0] reg3_i;
output [31:0] reg3_o;
input [31:0] reg4_i;
output [31:0] reg4_o;
input [31:0] reg5_i;
output [31:0] reg5_o;
input [31:0] reg6_i;
output [31:0] reg6_o;
input [31:0] reg7_i;
output [31:0] reg7_o;
input [31:0] reg8_i;
output [31:0] reg8_o;
input [31:0] reg9_i;
output [31:0] reg9_o;
input [31:0] reg10_i;
output [31:0] reg10_o;
input [31:0] reg11_i;
output [31:0] reg11_o;
input [31:0] reg12_i;
output [31:0] reg12_o;
input [31:0] reg13_i;
output [31:0] reg13_o;
input [31:0] reg14_i;
output [31:0] reg14_o;
input [31:0] reg15_i;
output [31:0] reg15_o;

reg [31:0] reg0;
reg [31:0] reg1;
reg [31:0] reg2;
reg [31:0] reg3;
reg [31:0] reg4;
reg [31:0] reg5;
reg [31:0] reg6;
reg [31:0] reg7;
reg [31:0] reg8;
reg [31:0] reg9;
reg [31:0] reg10;
reg [31:0] reg11;
reg [31:0] reg12;
reg [31:0] reg13;
reg [31:0] reg14;
reg [31:0] reg15;

assign reg0_o = reg0;
assign reg1_o = reg1;
assign reg2_o = reg2;
assign reg3_o = reg3;
assign reg4_o = reg4;
assign reg5_o = reg5;
assign reg6_o = reg6;
assign reg7_o = reg7;
assign reg8_o = reg8;
assign reg9_o = reg9;
assign reg10_o = reg10;
assign reg11_o = reg11;
assign reg12_o = reg12;
assign reg13_o = reg13;
assign reg14_o = reg14;
assign reg15_o = reg15;

/* Wishbone interface: */
always @(posedge wb_clk_i or posedge wb_rst_i) begin
  if (wb_rst_i) begin
    reg0 <= 32'd0;
    reg1 <= 32'd0;
    reg2 <= 32'd0;
    reg3 <= 32'd0;
    reg4 <= 32'd0;
    reg5 <= 32'd0;
    reg6 <= 32'd0;
    reg7 <= 32'd0;
    reg8 <= 32'd0;
    reg9 <= 32'd0;
    reg10 <= 32'd0;
    reg11 <= 32'd0;
    reg12 <= 32'd0;
    reg13 <= 32'd0;
    reg14 <= 32'd0;
    reg15 <= 32'd0;
  end else begin
    if (wb_cyc_i && wb_stb_i && wb_we_i && wb_sel_i[0]) begin
      case (wb_adr_i[5:2])
        4'd0: reg0 <= wb_dat_i;
        4'd1: reg1 <= wb_dat_i;
        4'd2: reg2 <= wb_dat_i;
        4'd3: reg3 <= wb_dat_i;
        4'd4: reg4 <= wb_dat_i;
        4'd5: reg5 <= wb_dat_i;
        4'd6: reg6 <= wb_dat_i;
        4'd7: reg7 <= wb_dat_i;
        4'd8: reg8 <= wb_dat_i;
        4'd9: reg9 <= wb_dat_i;
        4'd10: reg10 <= wb_dat_i;
        4'd11: reg11 <= wb_dat_i;
        4'd12: reg12 <= wb_dat_i;
        4'd13: reg13 <= wb_dat_i;
        4'd14: reg14 <= wb_dat_i;
        4'd15: reg15 <= wb_dat_i;
      endcase
    end
  end
end

reg [31:0] wb_dat;
assign wb_dat_o = wb_dat;
reg wb_ack;
assign wb_ack_o = wb_ack;
always @(*) begin
  wb_ack = wb_cyc_i && wb_stb_i;
  case (wb_adr_i[5:2])
    4'd0: wb_dat = reg0_i;
    4'd1: wb_dat = reg1_i;
    4'd2: wb_dat = reg2_i;
    4'd3: wb_dat = reg3_i;
    4'd4: wb_dat = reg4_i;
    4'd5: wb_dat = reg5_i;
    4'd6: wb_dat = reg6_i;
    4'd7: wb_dat = reg7_i;
    4'd8: wb_dat = reg8_i;
    4'd9: wb_dat = reg9_i;
    4'd10: wb_dat = reg10_i;
    4'd11: wb_dat = reg11_i;
    4'd12: wb_dat = reg12_i;
    4'd13: wb_dat = reg13_i;
    4'd14: wb_dat = reg14_i;
    4'd15: wb_dat = reg15_i;
  endcase
end

endmodule

